/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
/* 生词本模块：
*   定义 添加生词本方法 addScb , 成功添加回调方法 onScbSuccess
*/
/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////

/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.addScb(JSON.stringify({'uwid':uwid,'successCallback':'onScbSuccess'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    refreshStarIconStatus(uwid,in_scb);
}

//更新按钮样式
function refreshStarIconStatus(uwid,in_scb){
    var star = $('#addscb').find('img')[0];
    if(in_scb == '1'){
        star.src = _resource_+'/images/btn-added.png';
    }
    else if(in_scb == '0') {
        star.src = _resource_+'/images/btn-add.png';
    }
}

//播放声音接口
var globCurObj = null;
var defSoundSrc = null;
function playSound(jsonData,obj){
    jsonData = parseJson(jsonData);
    onEndPlaySound();
    globCurObj = $(obj);
    defSoundSrc = $(obj).attr('src');
    var name = jsonData.name ? jsonData.name : "";
    var lang = jsonData.lang ? jsonData.lang : "";
    var v = jsonData.v ? jsonData.v : "";
    var uwid = jsonData.uwid ? jsonData.uwid : "";
    try {
            dictcn.playSound(JSON.stringify({
                'uwid':uwid,
                'lang':lang,
                'name':name,
                'v': v,
                startCallback: "onStartPlaySound",
                endCallback: "onEndPlaySound",
                failedCallback: "onFailedPlaySound"
            }))
        } catch(f) {}
}

var globAnima = null;
var i = null;
function onStartPlaySound(jsonData){

    jsonData = parseJson(jsonData);
    try{
        i=1;
        playAnima();
    }catch(e){}
}

function playAnima()
{
    if(i>3) i=1;
    globCurObj.attr('src',_resource_+'/images/btn-voice-'+i+'.png');
    i++;
    globAnima=setTimeout("playAnima()",200);
}

/* 停止播放动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onEndPlaySound(jsonData){
    jsonData = parseJson(jsonData);
    try{
        clearTimeout(globAnima);
        globCurObj.attr('src', defSoundSrc);
    }catch(e){}
}

function onFailedPlaySound() {
//    $(playSouObj).removeClass('loading');
//    playSouObj.unClick = null;
//    playSouObj = null;
}

/* 查询成语
 * 参数格式string:
 */
function searchText(json){
	try{ dictcn.searchText(JSON.stringify(json)); }catch(e){}
}

function searchTextByUwid(json){
    try{ dictcn.searchText(JSON.stringify(json)); }catch(e){}
}

//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}
////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////
/* 学习类应用新增方法 模块：
*   定义
*/
//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////


/* 用户设置保存函数
 * 参数格式json:
 * jsonData = {
 *     "":"",                                 //
 * }
 */
//写入和读取 页面缓存
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value;
    if(isJson(jsonData.value)){
        value = JSON.stringify(jsonData.value) || "";
    }
    else {
        value = jsonData.value || "";
    }
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}
// getStorage 函数回调函数
function onPageID(json){
    json = parseJson(json);
    $.commFun.pageIDInit(json);
}

/** 录音功能模块
*   方法：
*       startRecord  （开始录音方法）
*       onStartRecord  （开始录音后的回调方法）
*       stopRecord  （停止录音方法）
*       onStopRecord  （停止录音后的回调方法）
*/
//录音功能
function startRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.startRecord(JSON.stringify({'uwid':uwid,'successCallback':'onStartRecord'})); }catch(e){}
}
function onStartRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    if(uwid){
        $.commFun.startRecordEvent(uwid);
    }
}
//停止录音
function stopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var invaild = jsonData.invaild || "";
    try{ dictcn.stopRecord(JSON.stringify({'uwid':uwid, "invaild":invaild,'successCallback':'onStopRecord'})); }catch(e){}
}
function onStopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    var filePath = jsonData.filePath || 0;
    if(uwid){
        $.commFun.stopRecordEvent(uwid,filePath);
    }    
}

/** 更新录音播放按钮状态模块
*   参数：
*       
*   方法：
*       refreshRecordPath （更新录音播放按钮状态）
*       onRefreshRecordPath （更新录音播放按钮状态 回调函数）
*/
//更新录音播放按钮状态
function refreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.refreshRecordPath(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshRecordPath'})); }catch(e){}
}
function onRefreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var filePath = jsonData.filePath || "";
    if(filePath){
        $.commFun.refreshListenSoundBtn(uwid, filePath);
    }
}

//更新添加到生词本按钮状态
function refreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
     var uwid = jsonData.uwid || "";
     try{ dictcn.refreshFavorite(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshFavorite'})); }catch(e){}
}
function onRefreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var isFavorite = jsonData.isFavorite || 0;//1|0
    $.commFun.refreshStarIconStatus(uwid,isFavorite);
}


/** 调用激活面板
*   参数：
*       
*   方法：
*       noticeToActivate （更新录音播放按钮状态）
*/
function noticeToActivate(){
    try{ dictcn.noticeToActivate(); }catch(e){}
}

/** js开给native接口：更新权限参数isActivate
*   参数：
*       status //标记状态的数值
*   方法：
*       refreshActivate （更新录音播放按钮状态）
*/
function refreshActivate(jsonData){
    jsonData = parseJson(jsonData);
    var status = jsonData.status;
    if(status >= 0){
    	isActivate = status;
    }
}

/**反馈当前打开词条信息给客户端
*   参数：
*       id  //pageID
*       uwid  //当前词条uwid
*       state： “1/0”  //是否已学习
*/
function refreshStudyStatus(jsonData){
    jsonData = parseJson(jsonData);
     var id = jsonData.id || "";
     var uwid = jsonData.uwid || "";
     var state = "1";
     try{ dictcn.refreshStudyStatus(JSON.stringify({'id':id, 'uwid':uwid, 'state':state})); }catch(e){}
}

//屏幕重新唤醒时 native 调用音频 reload方法
function audioReLoad(){
    if(isPlayingAll){
        if($.audioPlayer.getProgress() == 0){
            $.commFun.isPlayingAllTest();
            $.audioPlayer.reLoad();
        }
    }
}


//打开第二级页面方法
function enterConversation(jsonData){
    jsonData = parseJson(jsonData);
    var parent_id = jsonData.parent_id || "";
    try{ dictcn.enterConversation(JSON.stringify({'parent_id': parent_id})); }catch(e){}
}

/* 询问客户端是否有权限播放音频
 * requestSoundAuth方法参数：
 * {
 * "uwid": ""
 * "callbackType": ""
 * }
 * replySoundAuth
 * {
 * "uwid": ""
 * "auth": "1/0"
 * "callbackType": ""
 * }
 */
 function requestSoundAuth(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var callbackType = jsonData.callbackType || "";
    try{ dictcn.requestSoundAuth(JSON.stringify({'uwid': uwid, 'callbackType':callbackType, 'successCallback':'replySoundAuth'})); }catch(e){}
    // replySoundAuth({"uwid":uwid, "callbackType":callbackType, "auth":"1"});
 }
 //请求音频播放权限回调方法
 function replySoundAuth(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var auth = jsonData.auth || "";
    var callbackType = jsonData.callbackType || "";
    var sen = $('.sentence.active');
    var btn = $("#"+uwid).prev()[0];
    btn.reqauth = 0; //标记按钮未请求权限
    if(sen.attr('name') != uwid) return;
    $.commFun.replySoundAuthHandle(auth,callbackType);
 }
 //设置面板开放native接口
 //改变字体
 function changeFontSize(jsonData){
     jsonData = parseJson(jsonData);
     $('html').css('font-size',jsonData.font_size+"px");
     resizeSwiper();
 }
 // 完成设置方法
 function settingDone(jsonData){
     jsonData = parseJson(jsonData);
     settingRefresh(jsonData);
 }
 //完成设置后刷新界面方法
 function settingRefresh(jsonData){
     commSettingRefresh(jsonData); //多页面公共设置刷新界面方法
     $('.fixIconBtn').removeClass("hideAway");
 }

 //多页面公共设置刷新界面方法
 function commSettingRefresh(jsonData){
     var fontSize = jsonData.fontSize;
     var simpleColor = jsonData.simpleColor;
//     if((simpleColor == "1" || simpleColor == "0") && simpleColor != pageState.simpleColor){
//          refreshWebView(); //重刷页面
//          return;
//     }
     if(fontSize){
         $('html').css('font-size',fontSize+"px");
         resizeSwiper();
     }
 }

 /* 重绘当前webview
  */
  function refreshWebView(){
     // console.log("refreshWebView!!!");
     try{ dictcn.refreshWebView(); }catch(e){}
  }
 //重置滑动组件尺寸
 function resizeSwiper(tabBar,noCurPage){
     var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody;
     if(tabBar){ //仅重置tabBar元素所在swiper的尺寸
         if(!tabBar.length) return;
         //重置tabBar父容器swiper尺寸
         var height = tabBar.closest('.content').height();
         var slide = tabBar.parents('.swiper-slide');
         slide.eq(0).css('height', height);
         var s,startIndex;
         if(swiperBody.width){
             var index = slide.eq(1).index();
             s = swiperPages[index];
             startIndex = swiperBody.activeIndex;
             if(index != startIndex){
                 swiperBody.slideTo(index, 0, false);
                 noCurPage = 1;
             }
         }
         else {
             s = swiperMain;
         }
         s.onResize();
         s.update();
         // var btmLine = height * -1 + s.height;
         // s.params.btmLine = btmLine<0 ? btmLine : 0;
         s.params.btmLine = s.maxTranslate();
         if(swiperBody.width && noCurPage){
             swiperBody.slideTo(startIndex, 0, false);
         }
     }
     else{
         //重置整个页面swiper尺寸
         pubArgu.headHeight = -1*$('#header').height() || 0;
         var slide = swiperMain.slides[0];
         var conHei = $(slide).children().height();
         $(slide).css('height', conHei);
         swiperMain.onResize();
         // var btmLine = conHei * -1 + pubArgu.windowHeight;
         // swiperMain.params.btmLine = btmLine < 0 ? btmLine : 0;
         swiperMain.params.btmLine = swiperMain.maxTranslate();
         if(swiperBody.width){
             var i, len = swiperPages.length, height = [];
             pubArgu.headHeight = -1*$('#header').height();
             for(i=0; i<len; i++){
                 var hei = $(swiperPages[i].slides[0]).children().height();
                 height.push(hei);
             }
             for(i=0; i<len; i++){
                 var s = swiperPages[i];
                 $(s.slides[0]).css('height', height[i]);
                 s.onResize();
                 // var btmLine = height[i] * -1 + s.height;
                 // s.params.btmLine = btmLine<0 ? btmLine : 0;
                 s.params.btmLine = s.maxTranslate();
             }
         }
     }
 }