;(function($){
    /*----要排除出搜索范围的部分，请添加 “ no-serText ” 类名----*/
    var $sp,$input,curNum=0,lastNum=0,args,keyWord,iniGoWordLock,walkFilter,range;
    var isSerTextIng; //是否正在文内检索
    var specharRexp = {}; //特殊字符正则匹配表达式集合对象
    $.fn.searchText = function(options) {
        args = $.extend({}, $.fn.searchText.defaults, options);
        return this.each(function() {
            init(); //插件初始化
            creatSearchPanel(); //创建搜索面板
            relateThisBtn(this); //关联点击按钮
            changePanelStyle(); //根据是否获得焦点更新面板结构
            bindBtnClickEvent(); //绑定按钮点击事件
        });
    };
    // 默认参数
    $.fn.searchText.defaults = {
        hideIcon : null, //搜索按钮所处的按钮集合类名（用于整体隐藏）
        rootNode : document.body, //开始搜索的根节点
        specharRexpType : 0, //要应用的特殊字符正则匹配表达式类型
        foldLabelList : [], //隐藏内容标签类名列表
    };
    // 开放接口方法
    $.searchText = ({
        jumpWords:function(word){ //查词跳转方法
            word = word.trim();
            if(word){
                $sp.addClass('show');
                if(args.hideIcon){
                    args.hideIcon.addClass('hideAway');
                }
                iniGoWordLock = pubArgu.goWordLock;
                pubArgu.goWordLock = 1;
                $input.val(word);
                $sp.addClass('hasText');
                keyWord = word.toLowerCase();
                overSearch();
                startSearch(keyWord);
                isSerTextIng = 1;
            }
        },
        isSerTextIng:function(){ //告知是否正在文内检索
            return isSerTextIng;
        },
    });
    //初始化
    function init(){
        walkFilter = function(node){
            return (node.className && node.className.indexOf("no-serText") != -1) ? NodeFilter.FILTER_REJECT : NodeFilter.FILTER_ACCEPT;
        };
        specharRexpInit(); //初始化正则匹配对象
    }
    //创建搜索面板
    function creatSearchPanel(){
        var htmlText = '<div id="searchPanel" class="noResult"><div class="inputArea"><input type="text" class="key-word" placeholder="文内检索" /><div class="serResult"><span class="currentNum"></span>/<span class="totalNum"></span></div><div class="cleanText"></div></div><span class="previous-button"></span><span class="next-button"></span><span class="over-button">取消</span></div>';
        $('body').append(htmlText);
        $sp = $('#searchPanel');
        $input = $('#searchPanel input');
    }
    //关联点击按钮
    function relateThisBtn(btn){
        $(btn).on('click',function(e){
            if(pubArgu.showBrowserMenu) return;
            e.stopPropagation();
            $sp.addClass('show');
            $input.focus();
            if(args.hideIcon){
                args.hideIcon.removeClass('active').addClass('hideAway');
            }
            iniGoWordLock = pubArgu.goWordLock;
            pubArgu.goWordLock = 1;
            isSerTextIng = 1;
        });
    }
    //根据是否获得焦点更新面板结构
    function changePanelStyle(){
        if(isIOS){
            $input.focus(function(){
                setTimeout(function(){
                    var devi = $(window).height() - $sp.height();
                    var dis = $(window).scrollTop() + devi;
                    $sp.css({'position':'absolute', 'top':'0', '-webkit-transform': 'translateY('+dis+'px)', '-webkit-transition': '-webkit-transform 0s' });
                    $(window).bind('scroll', function(){
                        // console.log("实际滚动位置："+$(this).scrollTop());
                        var dis = $(this).scrollTop() + devi;
                        $sp.css({ '-webkit-transform': 'translateY('+dis+'px)' });
                    });
                    // $('html').one('touchmove',function(){
                    //     $input.blur();
                    // });
                }, 100);
            }).blur(function(){
                $sp.removeAttr('style');
                $(window).unbind('scroll');
            });
        }
    }
    //绑定按钮点击事件
    function bindBtnClickEvent(){
        //取消 , 完成按钮绑定方法
        $('#searchPanel .over-button').on('click',function(e){
            e.stopPropagation();
            overSearch();
            $sp.removeClass('show');
            if(args.hideIcon){
                args.hideIcon.removeClass('hideAway');
            }
            pubArgu.goWordLock = iniGoWordLock;
            isSerTextIng = 0;
            //设置swiper滑动，检测释义折叠
        });
        //键盘输入事件
        $input.on('input',function(){
            var newWord = this.value.trim().toLowerCase();
            if(newWord != keyWord){
                setTimeout(function(){
                    keyWord = newWord;
                    if(keyWord){
                        $sp.addClass('hasText');
                    }
                    else{
                        $sp.removeClass('hasText');
                    }
                    overSearch();
                    if(keyWord.length>1 || isCJK(keyWord)){
                        startSearch(keyWord);
                    }
                },100);
            }
        });
        $input.on('keyup',function(e){
            if(e.keyCode == 13){
                keyWord = this.value.trim().toLowerCase();
                overSearch();
                startSearch(keyWord);
            }
        });
        //上一个按钮绑定方法
        $('#searchPanel .previous-button').on('click',function(e){
            e.stopPropagation();
            gotoNeighbourRes("pre");
        });
        //下一个按钮绑定方法
        $('#searchPanel .next-button').on('click',function(e){
            e.stopPropagation();
            gotoNeighbourRes("next");
        });
        //清除文本按钮绑定方法
        $('#searchPanel .cleanText').on('click',function(e){
            e.stopPropagation();
            $input.val('');
            keyWord = "";
            $input.focus();
            overSearch();
            $sp.removeClass('hasText');
        });
    }
    //文本搜索方法
    // function startSearch(keyWord){
    //     var re = new RegExp(""+keyWord+"","gmi");
    //     if(keyWord){
    //         $('#swiperMain').find("*").contents()
    //         .filter(function(){
    //             return this.nodeType === 3;
    //         })
    //         .filter(function(){
    //             return this.nodeValue.toLowerCase().indexOf(keyWord) != -1;
    //         })
    //         .filter(function(){
    //             return $(this).parents('.no-serText').length == 0;
    //         })
    //         .each(function(){
    //             var htmlText = this.nodeValue.replace(re,"<pitch>"+"$&"+"</pitch>");
    //             var newNode = document.createElement("span");
    //             this.parentNode.replaceChild(newNode,this);
    //             newNode.outerHTML = htmlText;
    //         });
    //         followSearch();
    //     }
    // }
    //新文本搜索方法
    function startSearch(keyWord){
        if(keyWord){
            var startNode, startOffset, matchIndex;
            range = document.createRange();
            var keyLen = keyWord.length;
            var walker= document.createTreeWalker(args.rootNode, NodeFilter.SHOW_ALL, walkFilter, false);
            var re = speCharRe(keyWord[0]),re2;
            if(keyWord[1]){
                re2 = speCharRe(keyWord[0]+keyWord[1]);
            }
            // var time = new Date().getTime();
            var node = walker.nextNode();
            travelTree:
            while (node !== null) {
                if(node.nodeType === 3){
                    var nodeVal = node.nodeValue.toLowerCase();
                    var nodeLen = nodeVal.length;
                    if(startNode){
                        //继续匹配
                        // console.log("matchIndex: "+matchIndex)
                        var offsetP = 0; //一词对应多词时，比较位置偏移（作用于节点node）
                        for(var j = 0; j-offsetP<nodeLen; j++){
                            var curWord = keyWord[matchIndex+j];
                            var curNodeVal = nodeVal[j-offsetP];
                            if(curNodeVal != curWord){
                                var speChar = speCharMap(curNodeVal);
                                if(speChar && speChar.length > 1 && speChar[0]==curWord && speChar[1]==keyWord[matchIndex+j+1]){
                                    j++;
                                    offsetP++;
                                }
                                else if(speChar != curWord){
                                    startNode = null;
                                    startOffset = null;
                                    matchIndex = null;
                                    continue travelTree;
                                }
                            }
                            if((matchIndex+j) == (keyLen-1)){ //匹配到keyWord的最后一个字符了
                                range.setStart(startNode,startOffset);
                                range.setEnd(node, j+1-offsetP);
                                if(node.parentNode != startNode.parentNode){
                                    var fragment = range.extractContents();
                                    range.insertNode(fragment);
                                }
                                var pitch = document.createElement("pitch");
                                range.surroundContents(pitch);
                                startNode = null;
                                startOffset = null;
                                matchIndex = null;
                                // node = walker.nextNode();
                                // node = walker.nextSibling();
                                continue travelTree;
                            }
                            if(j-offsetP == nodeLen-1){ //匹配到node的最后一个字符，且还没匹配完
                                matchIndex = matchIndex + j + 1;
                            }
                        }
                    }
                    else{
                        //重新匹配
                        var mate = -1;
                        var addNodeLen = 0; //node节点长度补位
                        travelNode:
                        while(mate < nodeLen){
                            if(re && re.test(nodeVal)){
                                //替换首个特殊字符后再匹配
                                nodeVal = nodeVal.replace(re,keyWord[0]);
                            }
                            if(re2 && re2.test(nodeVal)){
                                //替换首个连字符后再匹配
                                nodeVal = nodeVal.replace(re2,keyWord[0]+keyWord[1]);
                                addNodeLen++;
                            }
                            mate = nodeVal.indexOf(keyWord[0],mate+1);
                            if(mate != -1){
                                // console.log(nodeVal)
                                if(keyLen > 1){
                                    if(mate+1 == nodeLen){
                                        startNode = node;
                                        startOffset = mate;
                                        matchIndex = 1;
                                        node = walker.nextNode();
                                        continue travelTree;
                                    }
                                    var offsetP = 0; //一词对应多词时，比较位置偏移（作用于节点node）
                                    for(var i = mate+1; i-offsetP < nodeLen+addNodeLen; i++){
                                        var curWord = keyWord[i-mate]; //当前比较的key字母
                                        var curNodeVal = nodeVal[i-offsetP]; //当前比较的node字母
                                        if(curNodeVal != curWord){
                                            var speChar = speCharMap(curNodeVal);
                                            if(speChar && speChar.length > 1 && speChar[0]==curWord && speChar[1]==keyWord[i-mate+1]){
                                                i++;
                                                offsetP++;
                                            }
                                            else if(speChar != curWord) continue travelNode;
                                        }
                                        if((i-mate) == (keyLen-1)){ //匹配到keyWord的最后一个字符了
                                            range.setStart(node,mate);
                                            range.setEnd(node,i+1-offsetP-addNodeLen);
                                            var pitch = document.createElement("pitch");
                                            range.surroundContents(pitch);
                                            node = walker.nextNode();
                                            node = walker.nextSibling();
                                            continue travelTree;
                                        }
                                        if(i-offsetP == nodeLen+addNodeLen-1){ //匹配到node的最后一个字符，且还没匹配完
                                            startNode = node;
                                            startOffset = mate;
                                            matchIndex = i - startOffset + 1;
                                            node = walker.nextNode();
                                            continue travelTree;
                                        }
                                    }
                                }
                                else{
                                    range.setStart(node,mate);
                                    range.setEnd(node,mate+1);
                                    var pitch = document.createElement("pitch");
                                    range.surroundContents(pitch);
                                    node = walker.nextNode();
                                    node = walker.nextSibling();
                                    continue travelTree;
                                }
                            }
                            else {
                                break;
                            }
                        }
                    }
                }
                node = walker.nextNode();
            }
            // console.log("搜索耗时： " + (new Date().getTime() - time))
            followSearch();
        }
    }
    //添加pitch标签后处理方法
    function followSearch(){
        if($('pitch').length){
            deploySerResPart(); //展开搜索结果中的隐藏部分
            $('pitch:hidden').each(function(){
                var element = $(this).parent()[0];
                $(this).replaceWith($('pitch').text());
                element.normalize();
            });
            $('pitch').eq(0).addClass('active');
            jumpResultWord();
        }
        $sp.addClass('showRes');
        var pitchLen = $('pitch').length;
        if(pitchLen){
            $sp.find('.currentNum').html('1');
            $sp.removeClass('noResult');
        }
        else {
            $sp.find('.currentNum').html('0');
            $sp.addClass('noResult');
        }
        $sp.find('.totalNum').html(pitchLen);
    }

    //跳转到相邻搜索结果方法
    function gotoNeighbourRes(dir){
        var $pitch = $('pitch');
        var pitchLen = $pitch.length;
        if(pitchLen){
            lastNum = curNum;
            if(dir == "pre"){
                curNum--;
                if(curNum < 0){
                    curNum = pitchLen-1;
                }
            }
            else if(dir == "next"){
                curNum++;
                if(curNum > pitchLen-1){
                    curNum = 0;
                }
            }
            $pitch.eq(lastNum).removeClass('active');
            $pitch.eq(curNum).addClass('active');
            jumpResultWord();
            $sp.find('.currentNum').html(curNum+1);
        }
    }
    //去除搜索结果标签
    function overSearch(){
        $('pitch').each(function(){
            var element = this.parentNode;
            var firstNode = this.firstChild;
            if((firstNode.nodeType == 1) && (firstNode.tagName == this.previousSibling.tagName)){
                var preNode = this.previousSibling;
            }
            var lastNode = this.lastChild;
            if((lastNode.nodeType == 1) && (lastNode.tagName == this.nextSibling.tagName)){
                var nextNode = this.nextSibling;
            }
            this.outerHTML = this.innerHTML;
            element.normalize();
            if(preNode){
                var merNode = preNode.nextSibling;
                preNode.innerHTML += merNode.innerHTML;
                preNode.normalize();
                element.removeChild(merNode);
            }
            if(nextNode){
                var merNode = nextNode.previousSibling;
                merNode.innerHTML += nextNode.innerHTML;
                merNode.normalize();
                element.removeChild(nextNode);
            }
        });
        curNum=0;
        $sp.removeClass('showRes').addClass('noResult');
    }
    //判断是否为中文
    function isCJK(str){
        var re = /[\u1100-\u11f9\u3041-\u30ff\u3104-\u312a\u3130-\u318e\u3400-\u4db5\u4e00-\u9fa5\uac00-\ud7a3\uf900-\ufa2c\uff66-\uff9e]/; 
        if(re.test(str)) return true;
        return false; 
    }
    //查词跳转页面方法
    function jumpResultWord(){
        var activeP = $('pitch.active');
        if(!activeP.length) return;
        var dis = activeP.offset().top;
        var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody, headHeight = pubArgu.headHeight;
        if(swiperBody.width){
            if(!activeP.parents("#swiperBody").length){
                swiperMain.setWrapperTranslate(0);
                return;
            }
            var id = activeP.parents('.swiper-slide').eq(1).index();
            swiperBody.slideTo(id, 0, true);
            dis = (dis - 80 - swiperPages[id].getWrapperTranslate() -swiperMain.getWrapperTranslate())* -1;
            if(dis > 0){
                dis = 0;
            }
            var btmLine = swiperPages[id].params.btmLine;
            if(dis >= headHeight){
                swiperMain.setWrapperTranslate(dis);
            }
            if(dis < headHeight) {
                if(dis-headHeight > btmLine){
                    swiperMain.setWrapperTranslate(headHeight);
                    swiperPages[id].setWrapperTranslate(dis - headHeight);
                }
                else {
                    swiperMain.setWrapperTranslate(headHeight);
                    swiperPages[id].setWrapperTranslate(btmLine);
                }
            }
        }
        else if(swiperMain.width){
            dis = (dis - swiperMain.getWrapperTranslate() -80)* -1;
            if(dis > 0){
                dis = 0;
            }
            var btmLine = swiperMain.params.btmLine;
            dis = dis<btmLine ? btmLine : dis;
            swiperMain.setWrapperTranslate(dis);
        }
        else {
            $("body").scrollTop(dis - 80);
        }
    }

    //初始化正则匹配对象
    function specharRexpInit(){
        if(args.specharRexpType == 1){
            frenchRexpInit(); //法语正则
        }
        else if(args.specharRexpType == 2){
            engRexpOneInit(); //英语正则一
        }
    }
    //法语正则
    function frenchRexpInit(){
        specharRexp = {
            "a" : /[\uF1A2\uF18A-\uF18D\uF2D0\uF2D1\u00C0-\u00C5\u00E0-\u00E5\u0100-\u0105\u0226\u0227]/,
            "c" : /[\uF18E\uF18F\uF2D2\u00C7\u00E7\u0106-\u010D\u0187\u0188]/,
            "e" : /[\uF190-\uF193\u00C8-\u00CB\u00E8-\u00EB\u0112-\u011B\u0228\u0229]/,
            "g" : /[\u011F]/,
            "h" : /[\u1E29]/,
            "i" : /[\uF194\uF195\u00CC-\u00CF\u00EC-\u00EF\u0128-\u0131\u0142]/,
            "n" : /[\u00F1]/,
            "o" : /[\uF198-\uF19A\u00D2-\u00D6\u00F2-\u00F6\u00F8\u014C-\u014F\u01D1-\u01D2]/,
            "r" : /[\u0159]/,
            "s" : /[\u015A\u015B\u015F\u0161]/,
            "t" : /[\u0163\u0165]/,
            "u" : /[\uF19B-\uF19E\u00D9-\u00DC\u00F9-\u00FC\u016A\u016B\u016E\u016F]/,
            "y" : /[\uF19F\u00FD\u00FF\u0178]/,
            "z" : /[\uF1A0\u017D\u017E]/,
            "ae" : /[\uF2D3-\uF2D5\u00C6\u00E6]/,
            "oe" : /[\uF1A1\u0152\u0153\u0276]/,
        };
    }
    //英语正则一
    function engRexpOneInit(){
        specharRexp = {
            "e" : /[\u00E9]/,
        };
    }
    
    //特殊字符返回匹配正则
    function speCharRe(char){
        return specharRexp[char];
    }
    //特殊字符映射易输入字符方法
    function speCharMap(char){
        var word;
        $.each(specharRexp, function(k,v){
            if(v.test(char)){
                word = k;
                return false;
            }
        });
        return word;
    }
    //展开搜索结果中的隐藏部分
    function deploySerResPart(){
        var arr = args.foldLabelList;
        for(var i=0, len=arr.length; i<len; i++){
            var fun = deployMethod[arr[i]+"Deploy"];
            if(fun){
                fun();
            }
        }
    }
    //展开标签方法集
    var deployMethod = {
        childrenDeploy : function(){
            $(".children").each(function(){
                var $this = $(this);
                if($this.children(".tabContent").find('pitch').length && !$this.hasClass("show")){
                    $this.addClass("show");
                    $.commFun.resizeSwiper($this);
                }
            });
        },
        hideExpDeploy : function(){
            $(".hideExp").each(function(){
                var $this = $(this);
                if($this.find('pitch').length){
                    if(!$this.hasClass("show")){
                        $this.addClass("show");
                        $this.prev().addClass('hide');
                        $.commFun.resizeSwiper($this);
                    }
                }
            });
        },
        compactModeDeploy : function(){
            $(".compactMode").each(function(){
                var $this = $(this);
            });
        },
    };
})(Zepto);