var pubArgu = {
	swiperPages: [],
	swiperMain: null,
	tagBar: null,
	swiperBody: null,
	goWordLock: 0,
	headHeight: null,
	windowHeight: null,
	tagBarHeight: null,
	showBrowserMenu: null, //标记浏览器长按菜单是否已显示
}; //公用的全局变量

$(function(){
	init();

	function fixPageHeight(){
		pubArgu.windowHeight = document.documentElement.clientHeight;
	    $('#swiperMain').css('height', pubArgu.windowHeight);
	    $('.swiperPages').css('height', pubArgu.windowHeight - pubArgu.tagBarHeight);
	}

	function init(){
		FastClick.attach(document.body);

		pubArgu.tagBarHeight = $('#tagBar').height();
		fixPageHeight();
		pubArgu.headHeight = -1*$('#header').height();

		swiperInit(); //滑动组件初始化

		bindClickEvent(); //绑定页面元素点击事件

		//文本搜索初始化
		$('#searchText').searchText({"hideIcon": $('.fixIconBtn'), "rootNode": $('#swiperMain')[0], "specharRexpType": 2, "foldLabelList": ["children","hideExp"]});
		if(connectWord && !auto_uwid){
			$.searchText.jumpWords(connectWord);
			connectWord = null;
		}

		extArgu = parseJson(extArgu);
		if(!extArgu) extArgu = {};
		//auto_uwid 词组或变位词跳转
		if(auto_uwid){
			var aim = $("[uwid='"+auto_uwid+"']");
			$.commFun.jumpToAim(aim);
			$.commFun.setFirstLoad(1);
			aim.find('.tabBar').click();
		}
		else if(extArgu.senseId || extArgu.pinyin){
			var s = pubArgu.swiperMain;
			if(extArgu.pinyin){
				var id = $.commFun.pyToIndex(extArgu.pinyin);
				pubArgu.swiperBody.slideTo(id, 0, true);
				s = pubArgu.swiperPages[id];
			}
			if(extArgu.senseId){
				var aim = s.slides.find('.senseCon').find(".sense"+extArgu.senseId);
				$.commFun.jumpToAim(aim);
			}
		}

		//网络图片下载请求
		$('.senseCon img').each(function(){
			var I = $(this);
			nativeLoadImage({"url":I.attr("url"), "image_id":I.attr("id")});
		});

		//每次用户选择文本改变时，告知客户端选择的文本内容
		var delayClickable;
		document.onselectionchange = function(){
			if($.searchText.isSerTextIng()) return;
			var str = window.getSelection().toString();
		    //tellSelectText(str);
		    if(delayClickable){
		    	clearTimeout(delayClickable);
		    	delayClickable = null;
		    }
		    if(str.length){
		    	pubArgu.showBrowserMenu = 1;
		    }
		    else {
		    	delayClickable = setTimeout(function(){
		    		pubArgu.showBrowserMenu = 0;
		    		delayClickable = null;
		    	},400);
		    }
		}

		//浏览器窗口改变时，重置swiper
		$(window).on("resize",windowSizeSwiper);

		//捕获阶段全局阻挡多点触控
		document.addEventListener('touchstart',function(e){
			if(e.touches.length > 1) e.stopPropagation();
		},true);

        settingRefresh({"fontSize":fontSize});
	}

	//绑定页面元素点击事件
	function bindClickEvent(){
		$('#addscb').click(function(){
            var uwid =$("#addscb").attr('uwid');
            var json = {'uwid': uwid};
            addScb(json);
    	});

		/*$('body').on('click','.yezuoCon',function(e){
			var htmlText = this.innerHTML;
			var json = {'text': htmlText};
			searchText(json);
		});

		$('body').on('click','.jinyiCon',function(e){
			var htmlText = this.innerHTML;
			var json = {'text': htmlText};
            searchText(json);
		});

		$('body').on('click','.fanyiCon',function(e){
			var htmlText = this.innerHTML;
			var json = {'text': htmlText};
            searchText(json);
		});*/

		$('.playSound').on('click',function(e){
            var name =$(this).attr('name');
            var uwid =$(this).attr('uwid');
            var lang =$(this).attr('lang');
            var v =$(this).attr('v');
            var json = {'name':name,'uwid':uwid,'lang':lang,'v':v};
            playSound(json,this);
        });

		$('er').on('click',function(e){
		    var uwid =$(this).attr('subuwid');
            var json = {'uwid':uwid};
//            var text = this.innerHTML;
//            var json = {'text':text};
            searchText(json);
		});
	}
	//标签栏点击事件
	function tabBarClick(This){
		var $This = $(This);
		var parent = $This.parent();
		parent.toggleClass('show');
		if(This.delayRf){
			clearTimeout(This.delayRf);
		}
		This.delayRf = setTimeout(function(){
			$.commFun.resizeSwiper($This);
			This.delayRf = null;
		},600);
		if(parent.hasClass('show') && !This.webReq){
			var uwid = parent.attr('uwid');
			if(parent.hasClass('children')){
				searchPhrase({"uwid":uwid, "successCallback":"onPhraseSuccess"});
			}
			else {
				searchPhrase({"uwid":uwid, "successCallback":"onChangeSuccess"});
			}
			This.webReq = 1;
		}
	}
	//点击重试按钮点击事件
	function reTryClickEvent(tgt){
		var parent = $(tgt).parents('.failLoad');
		var tabBar = parent.find('.tabBar')[0];
		if(!tabBar.webReq){
			var uwid = parent.attr('uwid');
			if(parent.hasClass('children')){
				searchPhrase({"uwid":uwid, "successCallback":"onPhraseSuccess"});
			}
			else {
				searchPhrase({"uwid":uwid, "successCallback":"onChangeSuccess"});
			}
			tabBar.webReq = 1;
		}
		parent.removeClass('failLoad');
	}

	//滑动组件初始化
	function swiperInit(){
		var startPos, startTran, isTouching;
		var goline = 100;
		var goPrev = $('.goPrev'), goNext = $('.goNext');
		var contTime = 0, foldline = 50;
		var multBody = 0; //标记是否多body
		if(pubArgu.tagBarHeight){
			foldline += pubArgu.tagBarHeight;
		}
	    pubArgu.swiperMain = new Swiper('#swiperMain', {
	    	direction: 'vertical',
	        slidesPerView: 'auto',
	        freeMode: true,
	        onInit: function(s){
	        	var slide = s.slides[0];
	        	var conHei = $(slide).children().height();
	        	if(slide.offsetHeight != conHei){
	        		$(slide).css('height', conHei);
	        		s.onResize();
	        	}
	        	var btmLine = conHei * -1 + pubArgu.windowHeight;
	        	s.params.btmLine = btmLine < 0 ? btmLine : 0;
	        	if($('#main-scrollbar').length){
	        		s.params.scrollbar = '#main-scrollbar';
	        		s.onResize();
	        	}
	        },
	        onTouchStart: function(s){
	        	goPrev.removeClass('ani');
		    	goNext.removeClass('ani');
		    	isTouching = 1;
		    	s.setWrapperTransition(0);
		    	s.setWrapperTranslate(s.getWrapperTranslate());
		    	s.params.disOffset = 0;
	        },
	        onSetTranslate: function(s,val){
	        	if(isTouching && !pubArgu.goWordLock){
	        		if(s.isBeginning){
	        			if(val > goline){
			        		goPrev.css({"-webkit-transform": "translateY("+(val-30)/3+"px)"});
			        		goPrev.addClass('rot');
			        	}
			        	else if(val > 30){
			        		var opa = Math.floor(Math.min(val-30, 100))/100;
			        		goPrev.css({"opacity": opa, "-webkit-transform": "translateY("+(val-30)/3+"px)"});
			        		goPrev.removeClass('rot');
			        	}
	        		}
	        		if(s.isEnd){
	        			var bl = s.params.btmLine;
						var tran = (val - bl + 30)/3;
			        	if(val < bl - goline){
			        		goNext.css({"-webkit-transform": "translateY("+tran+"px)"});
			        		goNext.addClass('rot');
			        	}
			        	else if(val < bl - 30){
			        		var opa = Math.floor(Math.min(-(val - bl + 30), 100))/100;
			        		goNext.css({"opacity": opa, "-webkit-transform": "translateY("+tran+"px)"});
			        		goNext.removeClass('rot');
			        	}
	        		}
	        		else if(!s.isBeginning){
	        			goPrev.attr('style',null);
	        			goNext.attr('style',null);
	        		}
	        	}
	        	//滚动折叠多余释义
	        	if(multBody || $.searchText.isSerTextIng()) return; //如果存在swiperBody,或正在文内检索，则取消检测
	        	if(contTime++ == 7){
					contTime = 0;
					$(s.slides[0]).find('.hideExp.show .foldExpBtn').each(function(){
						var dis = $(this).offset().top;
						if(dis < foldline){
							var parent = $(this).parent();
							parent.removeClass("show");
							parent.prev().removeClass('hide');
							$.commFun.resizeSwiper(parent);
							var off = dis - parent.prev().offset().top;
							s.params.disOffset += off;
							s.setWrapperTranslate(s.getWrapperTranslate() + off);
							$('#folding').removeClass("show");
						}
					});
				}
	        },
	        onTouchEnd: function(s){
	        	isTouching = 0;
	        	goPrev.addClass('ani').removeClass('rot');
	        	goPrev.attr('style',null);
	        	goNext.addClass('ani').removeClass('rot');
	        	goNext.attr('style',null);

	        	if(s.translate > goline && !pubArgu.goWordLock){
	        		goPrevWord();
	        	}
	        	else if(s.translate < s.params.btmLine - goline && !pubArgu.goWordLock){
	        		goNextWord();
	        	}
	        	else if(s.translate > 0){
	        		s.setWrapperTransition(200);
			    	s.setWrapperTranslate(0);
	        	}
	        	else if(s.translate < s.params.btmLine){
	        		s.setWrapperTransition(200);
			    	s.setWrapperTranslate(s.params.btmLine);
	        	}
	        },
	        onTransitionEnd: function(s){
	        	if(multBody || $.searchText.isSerTextIng()) return; //如果存在swiperBody,或正在文内检索，则取消检测
	        	$(s.slides[0]).find('.hideExp.show .foldExpBtn').each(function(){
	        		var dis = $(this).offset().top;
	        		if(dis < foldline){
						var parent = $(this).parent();
						parent.removeClass("show");
						parent.prev().removeClass('hide');
						var isend = s.isEnd;
						$.commFun.resizeSwiper(parent);
						if(!isend){
							var newdis = parent.prev().offset().top;
							s.setWrapperTranslate(s.getWrapperTranslate() - newdis + dis); //重定位
						}
						else{
							setTimeout(function(){
								var newdis = parent.prev().offset().top;
								s.setWrapperTranslate(s.getWrapperTranslate() - newdis + dis); //重定位
							},0);
						}
						$('#folding').removeClass("show");
					}
	        	});
	        }
	    });

	    pubArgu.tagBar = new Swiper('#tagBar', {
			slidesPerView : 3,
			onInit: function(s){
				if(s.slides.length < 3){
					s.params.slidesPerView = 2;
					s.onResize();
				}
			},
			onTap: function(s){
				pubArgu.swiperBody.slideTo(s.clickedIndex);
			}
	    });
	    var bodySwipering;
	    pubArgu.swiperBody = new Swiper('#swiperBody', {
	    	touchRatio : 0.7,
	    	onInit: function(){
	    		multBody = 1;
	    	},
	    	onSliderMove: function(){
	    		bodySwipering = 1;
	    	},
	    	onSlideChangeStart: function(){
	    		bodySwipering = 1;
				updateNavPosition();
			},
			onSlideChangeEnd: function(s){
	    		bodySwipering = 0;
	    		//检测释义展开状况，更新折叠按钮
	    		folding.aim = null;
	    		$(s.slides[s.activeIndex]).find('.hideExp.show .foldExpBtn').each(function(){
	    			folding.aim = this.parentNode;
	    		});
	    		if(folding.aim){
	    			folding.className = "show";
	    		}
	    		else{
	    			folding.className = "";
	    		}
			},
			onTouchEnd: function(){
				bodySwipering = 0;
			},
	    });
	    var firstSkip = 0, firstStep, mfirstStep;
	    $('.swiperPages').each(function(){
	    	var sp = new Swiper(this, {
		    	scrollbar: $(this).find('.swiper-scrollbar'),
		        direction: 'vertical',
		        slidesPerView: 'auto',
		        freeMode: true,
		        lock: 0,
		        onInit: function(s){
		        	var slide = s.slides[0];
		        	var conHei = $(slide).children().height();
		        	if(slide.offsetHeight != conHei){
		        		$(slide).css('height', conHei);
		        		s.onResize();
		        		s.update();
		        	}
		        	var btmLine = conHei * -1 + s.height;
		        	s.params.btmLine = btmLine < 0 ? btmLine : 0;
		        },
		        onTouchStart: function(s){
			    	startPos = s.translate;
			    	startTran = pubArgu.swiperMain.translate;
			    	firstSkip = 0;
			    	s.params.disOffset = 0;
			    	s.setWrapperTransition(0);
			    	s.setWrapperTranslate(s.getWrapperTranslate());
			    },
			    onTouchMove: function(swiper){
			    	// console.log(bodySwipering)
			    	var headHeight = pubArgu.headHeight, swiperMain = pubArgu.swiperMain;
			    	if(!bodySwipering){
			    		var diff = swiper.touches.diff;
				    	var pos = startPos + diff;
				    	if(startTran <= 0 && startTran > headHeight){
				    		var mainPos = startTran + diff;
				    		if(firstSkip){
						    	if(mainPos < 0 && mainPos > headHeight){
						    		var dis = mainPos;
					    			swiperMain.setWrapperTransition(0);
					    			swiperMain.setWrapperTranslate(dis);
						    	}
						    	else if(mainPos <= headHeight){
						    		swiperMain.setWrapperTranslate(headHeight);
						    		if(!firstStep){
										firstStep = swiper.getK();
									}
									swiper.setWrapperTranslate(swiper.getK()-firstStep+swiper.params.disOffset);
						    	}
						    	else if(mainPos >= 0){
						    		swiperMain.setWrapperTransition(0);
						    		if(!mfirstStep){
										mfirstStep = swiper.getK();
									}
									swiperMain.setWrapperTranslate(swiper.getK()-mfirstStep);
						    	}
						    }
						    else {
						    	firstSkip = 1;
						    	if(mainPos >= 0 && !mfirstStep){
									mfirstStep = 0.1;
						    	}
						    }
				    	}
				    	else {
				    		if(firstSkip){
				    			if(pos <= 0){
						    		var dis = pos;
						    		var bl = swiper.params.btmLine;
						    		swiperMain.setWrapperTranslate(headHeight);
						    		if(dis > bl){
						    			swiper.setWrapperTranslate(dis+swiper.params.disOffset);
						    		}
						    		else {
						    			swiper.setWrapperTranslate(swiper.getK()+swiper.params.disOffset);
						    		}
						    	}
						    	else if(pos > 0){
						    		swiper.setWrapperTranslate(0);
						    		swiperMain.setWrapperTransition(0);
									var dis = pos + headHeight;
									if(dis < 0 ){
										swiperMain.setWrapperTranslate(dis);
									}
									else {
										if(!firstStep){
											firstStep = swiper.getK();
										}
										swiperMain.setWrapperTranslate(swiper.getK()-firstStep);
									}
						    	}
				    		}
				    		else {
				    			firstSkip = 1;
				    		}
				    	}
			    	}
				},
				onTouchEnd: function(swiper){
			    	firstStep = 0;
			    	mfirstStep = 0;
			    	isTouching = 0;
			    	var swiperMain = pubArgu.swiperMain;
			    	if(swiperMain.translate > 0){
			    		if(swiperMain.translate > goline && !pubArgu.goWordLock){
			        		goPrevWord();
			        	}
			    		swiperMain.setWrapperTransition(200);
			    		swiperMain.setWrapperTranslate(0);
			    	}
			    	setTimeout(function(){
			    		if(swiper.translate < 0){
				    		swiperMain.setWrapperTransition(200);
				    		swiperMain.setWrapperTranslate(pubArgu.headHeight);
				    	}
				    	else if(swiper.translate > 50){
				    		swiperMain.setWrapperTransition(200);
				    		swiperMain.setWrapperTranslate(0);
				    	}
			    	},10);
			    	var s = swiper;
		        	if(s.translate < s.params.btmLine - goline && !pubArgu.goWordLock){
		        		goNextWord();
		        	}
		        	else if(s.translate > 0){
		        		s.setWrapperTransition(200);
				    	s.setWrapperTranslate(0);
		        	}
		        	else if(s.translate < s.params.btmLine){
		        		s.setWrapperTransition(200);
				    	s.setWrapperTranslate(s.params.btmLine);
		        	}
				},
				onSetTranslate: function(swiper,val){
					if(isTouching && swiper.isEnd && !pubArgu.goWordLock){
						var bl = swiper.params.btmLine;
						var tran = (val - bl + 30)/3;
			        	if(val < bl - goline){
			        		goNext.css({"-webkit-transform": "translateY("+tran+"px)"});
			        		goNext.addClass('rot');
			        	}
			        	else if(val < bl - 30){
			        		var opa = Math.floor(Math.min(-(val - bl + 30), 100))/100;
			        		goNext.css({"opacity": opa, "-webkit-transform": "translateY("+tran+"px)"});
			        		goNext.removeClass('rot');
			        	}
			        	else {
			        		goNext.attr('style',null);
			        	}
					}
					if($.searchText.isSerTextIng()) return; //如果正在文内检索，则取消检测
					if(contTime++ == 7){
						contTime = 0;
						$(swiper.slides[0]).find('.hideExp.show .foldExpBtn').each(function(){
							var dis = $(this).offset().top;
							if(dis < foldline){
								var parent = $(this).parent();
								parent.removeClass("show");
								parent.prev().removeClass('hide');
								$.commFun.resizeSwiper(parent);
								var off = dis - parent.prev().offset().top;
								swiper.params.disOffset += off;
								swiper.setWrapperTranslate(swiper.getWrapperTranslate() + off);
								$('#folding').removeClass("show");
							}
						});
					}
		        },
		        onTransitionEnd: function(s){
		        	if($.searchText.isSerTextIng()) return; //如果正在文内检索，则取消检测
		        	$(s.slides[0]).find('.hideExp.show .foldExpBtn').each(function(){
		        		var dis = $(this).offset().top;
		        		if(dis < foldline){
							var parent = $(this).parent();
							parent.removeClass("show");
							parent.prev().removeClass('hide');
							var isend = s.isEnd;
							$.commFun.resizeSwiper(parent);
							if(!isend){
								var newdis = parent.prev().offset().top;
								s.setWrapperTranslate(s.getWrapperTranslate() - newdis + dis); //重定位
							}
							else{
								setTimeout(function(){
									var newdis = parent.prev().offset().top;
									s.setWrapperTranslate(s.getWrapperTranslate() - newdis + dis); //重定位
								},0);
							}
							$('#folding').removeClass("show");
						}
		        	});
		        }
		    });
		    pubArgu.swiperPages.push(sp);
	    });
	}

    //tagBar滑动切换
    function updateNavPosition(){
		$('#tagBar .active-nav').removeClass('active-nav');
		var activeNav = $('#tagBar .swiper-slide').eq(pubArgu.swiperBody.activeIndex).addClass('active-nav');
		var tagBar = pubArgu.tagBar;
		var num = tagBar.params.slidesPerView;
		if (activeNav.index() > tagBar.activeIndex + num - 2) {
			var aimIndex = activeNav.index() + 2 - num;
			tagBar.slideTo(aimIndex);
		}
		else if (activeNav.index() < tagBar.activeIndex + 1) {
			var aimIndex = activeNav.index() - 1;
			tagBar.slideTo(aimIndex);
		}
	}
	//切换上一个词
	function goPrevWord(){
		var uwid = $('.goPrev').find('p').attr('uwid');
		if(uwid){
			searchText({'uwid':uwid});
		}
	}
	//切换下一个词
	function goNextWord(){
		var uwid = $('.goNext').find('p').attr('uwid');
		if(uwid){
			searchText({'uwid':uwid});
		}
	}

	//浏览器窗口尺寸改变时，重置swiper
	function windowSizeSwiper(){
		// var oldWinHeight = windowHeight;
		fixPageHeight();
		pubArgu.swiperMain.onResize();
		if(pubArgu.swiperBody.width){
			var i, len = pubArgu.swiperPages.length, height = [];
			for(i=0; i<len; i++){
				height.push(pubArgu.swiperPages[i].slides[0].clientHeight);
			}
			for(i=0; i<len; i++){
				var s = pubArgu.swiperPages[i];
				s.onResize();
				var btmLine = height[i] * -1 + s.height;
				s.params.btmLine = btmLine<0 ? btmLine : 0;
				// s.params.btmLine += windowHeight - oldWinHeight;
				// console.log(s.params.btmLine)
			}
		}
		else{
			var height = pubArgu.swiperMain.slides[0].clientHeight;
			var btmLine = height * -1 + pubArgu.swiperMain.height;
	        pubArgu.swiperMain.params.btmLine = btmLine<0 ? btmLine : 0;
		}
	}

});